
subroutine CalcEnergyForces(Pos, PosWB, PosWC, Lx, W, Lz, Cut, PEnergy, Forces, Dim, NAtom)
    implicit none
    integer, intent(in) :: Dim, NAtom
    real(8), intent(in), dimension(0:NAtom-1, 0:Dim-1) :: Pos, PosWB, PosWC
    real(8), intent(in) :: Lx, W, Lz, Cut
    real(8), intent(out) :: PEnergy
    real(8), intent(inout), dimension(0:NAtom-1, 0:Dim-1) :: Forces
!f2py intent(in, out) :: Forces
    !======== YOUR CODE HERE ========
    real(8), dimension(Dim) :: rij, Posi, Fij, wrij
    real(8) :: d2, id2, id3, id6, id9, id12, rc2, rcw2, rcw6, ircw3, ircw9, PEshiftw, irc2, irc6, irc12, PEshift
    real(8) :: rhosig3, sigr1, sigr2, sigr13, sigr23, sigr19, Epsr, wrrij, iwrrij
    integer :: i, j
    real(8), parameter :: pi = 3.14159265
!real(8), parameter :: pi = 3.141592653589793239

! add shift
    epsr=0.78
    Sigr1=1.093
    sigr2=0.5
    rhosig3=2.709
    sigr13=sigr1*sigr1*sigr1
    sigr19=sigr13*sigr13*sigr13
    sigr23=sigr2*sigr2*sigr2
    
    rcw2=1000.
    rcw6=rcw2*rcw2*rcw2
    ircw3=1./sqrt(rcw6)
    ircw9=ircw3/rcw6
    PEnergy = 0.
    Forces=0.
    rc2=cut*cut
    irc2=1./rc2
    irc6=irc2*irc2*irc2
    irc12=irc6*irc6
    PEshift=4.*(irc12-irc6)
    PEshiftw=(4.*pi*Epsr*rhosig3*sigr23/3.)*(1./15.*ircw9*Sigr19-1./2.*ircw3*Sigr13)
    do i=0, NAtom-1
        Posi=Pos(i,:)
! particle particle interaction
        do j=i+1,NAtom-1
            rij=Pos(j,:)-Posi
            !print *, "rij", rij
            !print *, rij(1), rij(2)
            rij(1)=rij(1)-Lx*dnint(rij(1)/Lx)
            rij(3)=rij(3)-Lz*dnint(rij(2)/Lz)
            d2=sum(rij*rij)
            if (d2 < rc2) then
                id2=1./d2
                id6=id2*id2*id2
                id12=id6*id6
                PEnergy=PEnergy+4.*(id12-id6)-PEshift
                Fij = rij * ((-48. * id12 + 24. * id6) * id2)
                Forces(i,:) = Forces(i,:) + Fij
                Forces(j,:) = Forces(j,:) - Fij
            endif
        enddo
        wrij=PosWB(i,:)-Posi
        d2=sum(wrij*wrij)
        id2=1./d2
        wrrij=sqrt(d2)
        iwrrij=1./wrrij
        
        id3=id2*iwrrij
        id6=id2*id2*id2
        PEshift=(4.*pi*Epsr*rhosig3*sigr23/3.)*(1./15.*id6*id3*Sigr19-1./2.*id3*Sigr13)
        if (d2 < rcw2) then
            id2=1./d2
            id6=id2*id2*id2
            id12=id6*id6
            PEnergy=PEnergy+(4.*pi*Epsr*rhosig3*sigr23/3.)*(1./15.*id6*id3*Sigr19-1./2.*id3*Sigr13)-PEshiftw
            Fij = wrij * (4.*pi*Epsr*rhosig3*sigr23/3.)*((-9./15. * id6*id3*Sigr19 + 3./2. * id3*Sigr13) * id2)
            Forces(i,:) = Forces(i,:) + Fij

        endif
        
        wrij=PosWC(i,:)-Posi
        d2=sum(wrij*wrij)
        id2=1./d2
        wrrij=sqrt(d2)
        iwrrij=1./wrrij
        id3=id2*iwrrij
        id6=id2*id2*id2
        if (d2 < rcw2) then
            id2=1./d2
            id6=id2*id2*id2
            id12=id6*id6
            PEnergy=PEnergy+(4.*pi*Epsr*rhosig3*sigr23/3.)*(1./15.*id6*id3*Sigr19-1./2.*id3*Sigr13)-PEshiftw
            Fij = wrij * (4.*pi*Epsr**rhosig3*sigr23/3.)*((-9./15. * id6*id3*Sigr19 + 3./2. * id3*Sigr13) * id2)
            Forces(i,:) = Forces(i,:) + Fij
        endif
        
        
! add particle-wall interaction
    enddo

end subroutine


subroutine CalcEnergy(Pos, PosWB, PosWC, Lx, W, Lz, Cut, PEnergy, Dim, NAtom)
    implicit none
    integer, intent(in) :: Dim, NAtom
    real(8), intent(in), dimension(0:NAtom-1, 0:Dim-1) :: Pos, PosWB, PosWC
    real(8), intent(in) :: Lx, W, Lz, Cut
    real(8), intent(out) :: PEnergy
    !======== YOUR CODE HERE ========
    integer :: i, j
    real(8), dimension(Dim) :: rij, Posi, wrij
    real(8) :: d2, id2, id3, id6, id9, id12, rrij, rcw2, rcw6, ircw3, ircw9, PEshiftw, rc2, irc2, irc6, irc12, PEshift
    real(8) :: rhosig3, sigr1, sigr2, sigr13, sigr23, sigr19, Epsr, wrrij, iwrrij
    real(8), parameter :: pi = 3.14159265


    Epsr=0.78
    Sigr1=1.093
    sigr2=0.5
    rhosig3=2.709
    Sigr13=Sigr1*Sigr1*Sigr1
    sigr23=sigr2*sigr2*sigr2
    Sigr19=Sigr13*Sigr13*Sigr13
    rcw2=1000.
    rcw6=rcw2*rcw2*rcw2
    ircw3=1./sqrt(rcw6)
    ircw9=ircw3/rcw6
    rc2=Cut*Cut 
    PEnergy = 0.
    irc2=1./rc2
    irc6=irc2*irc2*irc2
    irc12=irc6*irc6
    PEshift=4.*(irc12-irc6)
    PEshiftw=(4.*pi*Epsr*rhosig3*sigr23/3.)*(1./15.*ircw9*Sigr19-1./2.*ircw3*Sigr13)

    do i=0, NAtom-1
        Posi=Pos(i,:)
        do j=i+1,NAtom-1
            rij=Pos(j,:)-Posi
            rij(1)=rij(1)-Lx*dnint(rij(1)/Lx)
            rij(3)=rij(3)-Lz*dnint(rij(2)/Lz)

            d2=sum(rij*rij)
            if (d2 < rc2) then
                ! need a code to escape when d2 > rc^2
                id2=1./d2
                id6=id2*id2*id2
                id12=id6*id6
                PEnergy=PEnergy + 4.*(id12-id6)-PEshift

            endif
        enddo
        wrij=PosWB(i,:)-Posi
        d2=sum(wrij*wrij)
        id2=1./d2
        wrrij=sqrt(d2)
        iwrrij=1./wrrij
        id3=id2*iwrrij
        id6=id2*id2*id2
        if (d2 < rc2) then
            id2=1./d2
            id6=id2*id2*id2
            id12=id6*id6
            PEnergy=PEnergy+(4.*pi*Epsr*rhosig3*sigr23/3.)*(1./15.*id6*id3*Sigr19-1./2.*id3*Sigr13)-PEshiftw
        
        endif
        wrij=PosWC(i,:)-Posi
        d2=sum(wrij*wrij)
        id2=1./d2
        wrrij=sqrt(d2)
        iwrrij=1./wrrij
        id3=id2*iwrrij
        id6=id2*id2*id2
        if (d2 < rc2) then
            id2=1./d2
            id6=id2*id2*id2
            id12=id6*id6
            PEnergy=PEnergy+(4.*pi*Epsr*rhosig3*sigr23/3.)*(1./15.*id6*id3*Sigr19-1./2.*id3*Sigr13)-PEshiftw
        endif

        
    enddo

end subroutine



subroutine VVIntegrate(Pos, PosWB, PosWC, Vel, Accel, Lx, W, Lz, Cut, dt, KEnergy, PEnergy, Dim, NAtom)
    implicit none
    integer, intent(in) :: Dim, NAtom
    real(8), intent(in) :: Lx, W, Lz, Cut, dt
    real(8), intent(inout), dimension(0:NAtom-1, 0:Dim-1) :: Pos, Vel, Accel
!f2py intent(in,out) :: Pos, Vel, Accel
    real(8), intent(in), dimension(0:NAtom-1, 0:Dim-1) :: PosWB, PosWC
    real(8), intent(out) :: KEnergy, PEnergy
    external :: CalcEnergyForces
    integer :: i, j
    
    Pos = Pos + dt * Vel + 0.5 * dt*dt * Accel
    Vel = Vel + 0.5 * dt * Accel
    call CalcEnergyForces(Pos, PosWB, PosWC, Lx, W, Lz, Cut, PEnergy, Accel, Dim, NAtom)
    Vel = Vel + 0.5 * dt * Accel
    KEnergy = 0.5 * 32.*sum(Vel*Vel)
        
end subroutine